// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "vmenu.h"

#include "MainFrm.h"

extern CVmenuApp theApp;
ofstream& log = theApp.fOut;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_KEYDOWN()
	ON_COMMAND(CHANGE_A, OnA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	m_tmpWnd.InitLog(&theApp.fOut, true, true, true);
	m_tmpWnd.InitItemTitles(3);
	
	m_tmpWnd.InitItemTitles(3);
	m_tmpWnd.AddItemTitle(" 1");
	m_tmpWnd.AddItemTitle(" 2");
	m_tmpWnd.AddItemTitle(" 3");
	
    m_tmpWnd.SetCoordinates(0, 0);
	
	if (!m_tmpWnd.Create(NULL, NULL, WS_CHILD,
		CRect(m_tmpWnd.GetMenuRect()), &m_wndView, 6666, NULL))
	{
		TRACE0("Failed to create my temporary window\n");
		return -1;
	}
	m_tmpWnd.Show();

	XEvent e(sizeof(int));

	e.m_Number = 1001;
	m_tmpWnd.ReceiveEvent(e);	
	e.m_Number = 1002;
	*((int*)(e.m_Info)) = 1;
	m_tmpWnd.ReceiveEvent(e);
		
	m_tmpWnd.ShowWindow(theApp.m_nCmdShow);	

/*****************************************************************************************
** Sub  Menu ******************************************************************************
*****************************************************************************************/

	m_tmpSub.SetDirection(MD_VERTICAL);
	m_tmpSub.InitLog(&theApp.fOut, true, true, true);
	m_tmpSub.InitItemTitles(3);
	
	int x, y;
	m_tmpWnd.GetSubMenuCoordinates(1, x, y);
	m_tmpSub.SetCoordinates(x, y);
	m_tmpSub.AddItemTitle(" 1");
	m_tmpSub.AddItemTitle(" 2");
	m_tmpSub.AddItemTitle(" 3");


	if (!m_tmpSub.Create(NULL, NULL, WS_CHILD,
		CRect(m_tmpSub.GetMenuRect()), &m_wndView, 6667, NULL))
	{
		TRACE0("Failed to create my temporary window\n");
		return -1;
	}

	m_tmpSub.ShowWindow(theApp.m_nCmdShow);	
	m_tmpSub.MoveWindow(0, 0, 0, 0);

/*****************************************************************************************
** Sub2 Menu ******************************************************************************
*****************************************************************************************/
	
	m_tmpSub2.SetDirection(MD_VERTICAL);
	m_tmpSub2.InitLog(&theApp.fOut, true, true, true);
	m_tmpSub2.InitItemTitles(3);
	
	m_tmpSub2.AddItemTitle(" 1");
	m_tmpSub2.AddItemTitle(" 2");
	m_tmpSub2.AddItemTitle(" 3");
	
	m_tmpSub.GetSubMenuCoordinates(3, x, y);
    m_tmpSub2.SetCoordinates(x, y);
	if (!m_tmpSub2.Create(NULL, NULL, WS_CHILD,
		CRect(m_tmpSub2.GetMenuRect()), &m_wndView, 6667, NULL))
	{
		TRACE0("Failed to create my temporary window\n");
		return -1;
	}

	m_tmpSub2.ShowWindow(theApp.m_nCmdShow);	
	m_tmpSub2.MoveWindow(0, 0, 0, 0);
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	// m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{

	char tmp[2];
	tmp[0] = (char)nChar;
	tmp[1] = 0;
	
	log << endl << ">> Key pressed: " << tmp << " (" << nChar << ")" << endl;
	bool ok = 1;

	XEvent e(sizeof(int));
	if (nChar == 0x41)      // key A
	{
		e.m_Number = 1002;
		*((int*)(e.m_Info)) = 1;
	}
	else if (nChar == 0x57) // key W
	{
		e.m_Number = 1001;		
	}
	else if (nChar == 0x43) // key C
	{
		e.m_Number = 1004;
	}
	else if (nChar == 0x4e) // key N
	{
		e.m_Number = 1005;
	}
	else if (nChar == 0x50) // key P
	{
		e.m_Number = 1006;
	}
	else if (nChar == 0x53) // key S
	{
		e.m_Number = 1003;
	}
	else if (nChar == VK_ESCAPE)
	{
		e.m_Number = 1007;
	}
	else if (nChar == VK_RETURN) 
	{
		e.m_Number = 1008;
	} else	{
		ok = 0;
	}

	if (ok) {
		m_tmpWnd.ReceiveEvent(e);
		m_tmpWnd.InvalidateRect(NULL);
		m_tmpSub.InvalidateRect(NULL);
		m_tmpSub2.InvalidateRect(NULL);
	}

	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMainFrame::OnA() 
{
	int num = m_tmpSub2.GetItemsNumber();
	num++;

	char* str1 = new char[20];
	
	sprintf(str1, "Active %d", num);
	XCoolSub2Active3* sub2act4 = new XCoolSub2Active3(str1); 
	sprintf(str1, "Selected %d", num);
	XMenuSelected* sub2sel4 = new XMenuSelected(str1);
	sub2act4->SetParent(&m_tmpSub2);
	sub2sel4->SetParent(&m_tmpSub2);
	m_tmpSub2.AddState(sub2act4);
	m_tmpSub2.AddState(sub2sel4);

	m_tmpSub2.ClearItemTitles();
	m_tmpSub2.InitItemTitles(num);

	for (int i = 0; i < num; i++)
	{
		sprintf(str1, " %d", (i+1));
		m_tmpSub2.AddItemTitle(str1);
	}
	
	m_tmpSub2.Show();
}
