#include <fstream>
#include "xcustommenu.h"

#include "mainfrm.h"
#include "vmenu.h"

extern CVmenuApp theApp;
ofstream& fOut2 = theApp.fOut;

XCoolActive1* act1;
XCoolActive2* act2;
XCoolActive3* act3;

XMenuSelected* sel1;
XCoolSelected2* sel2;
XMenuSelected* sel3;


void z10(XMenuWnd* a)
{
	a->MoveWindow(0, 0, 0, 0);
}

void z20(XMenuWnd* a)
{
	a->MoveWindow(&(a->GetMenuRect()));	
}


int XCoolClosed::ChangeState(const XEvent &e)
{
	int next = XMenuClosed::ChangeState(e);
	if (next == 1)
	{
		z20((XMenuWnd*)GetParent()); 
	}
	return next;
}

void XCoolClosed::EnterInfluence()
{
	z10((XMenuWnd*)GetParent());
	
	XMenuClosed::EnterInfluence();
}


XCoolSub1Menu::XCoolSub1Menu(void)
{

	act1 = new XCoolActive1("Active 1");
	act2 = new XCoolActive2("Active 2");
	act3 = new XCoolActive3("Active 3");

	sel1 = new XMenuSelected("Selected 1");
	sel2 = new XCoolSelected2("Selected 2");
	sel3 = new XMenuSelected("Selected 3");

	SetTitle("A0");
	XCoolClosed* cls = new XCoolClosed("Closed");
	InsertState(cls, 0);
	((XStateEx*)(GetState(0)))->SetParent(this);
	((XStateEx*)(GetState(1)))->SetParent(this);
	((XStateEx*)(GetState(1)))->SetTitle("Waiting");
	act1->SetParent(this);
	act2->SetParent(this);
	act3->SetParent(this);
	sel1->SetParent(this);
	sel2->SetParent(this);
	sel3->SetParent(this);
	AddState(act1);
	AddState(sel1);
	AddState(act2);
	AddState(sel2);
	AddState(act3);
	AddState(sel3);
}

XCoolSub1Menu::~XCoolSub1Menu(void)
{
	TerminateLog();
	delete act1;
	delete act2;
	delete act3;
	delete sel1;
	delete sel2;
	delete sel3;
}


void z1_1()
{	
	fOut2 << "action in z1_1" << endl;
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z1_1()!", "Menu action!", MB_OK);
}

void z1_2()
{
	fOut2 << "action in z1_2" << endl;
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z1_2()!", "Menu action!", MB_OK);
}
 
void z1_3()
{
	fOut2 << "action in z1_3" << endl;
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z1_3()!", "Menu action!", MB_OK);	
}


int XCoolActive1::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z1_1();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}

int XCoolActive2::ChangeState(const XEvent &e)
{
	return XMenuActive::ChangeState(e);
}

int XCoolSelected2::ChangeState(const XEvent &e)
{
	// Nested automat call here
	((CMainFrame*)(theApp.m_pMainWnd))->m_tmpSub.ReceiveEvent(e);

	return XMenuSelected::ChangeState(e);
}

int XCoolActive3::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z1_3();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}

void XCoolSelected2::EnterInfluence()
{
	XEvent e;
	e.m_Number = 0;
	// Nested automat initialization
	((CMainFrame*)(theApp.m_pMainWnd))->m_tmpSub.ReceiveEvent(e);

	XMenuSelected::EnterInfluence();
}
/*****************************************************************************************
** Sub Menu ******************************************************************************
*****************************************************************************************/

XCoolSubActive1* subact1;
XCoolSubActive2* subact2;
XCoolSubActive3* subact3;

XMenuSelected* subsel1;
XMenuSelected* subsel2;
XCoolSubSelected3* subsel3;


XCoolSub2Menu::XCoolSub2Menu(void)
{

	subact1 = new XCoolSubActive1("Active 1");
	subact2 = new XCoolSubActive2("Active 2");
	subact3 = new XCoolSubActive3("Active 3");

	subsel1 = new XMenuSelected("Selected 1");
	subsel2 = new XMenuSelected("Selected 2");
	subsel3 = new XCoolSubSelected3("Selected 3");

	SetTitle("A1");
	XCoolClosed* cls = new XCoolClosed("Closed");
	InsertState(cls, 0);	
	((XStateEx*)(GetState(0)))->SetParent(this);
	((XStateEx*)(GetState(1)))->SetParent(this);
	((XStateEx*)(GetState(1)))->SetTitle("Waiting");
	subact1->SetParent(this);
	subact2->SetParent(this);
	subact3->SetParent(this);
	subsel1->SetParent(this);
	subsel2->SetParent(this);
	subsel3->SetParent(this);
	AddState(subact1);
	AddState(subsel1);
	AddState(subact2);
	AddState(subsel2);
	AddState(subact3);
	AddState(subsel3);
}

XCoolSub2Menu::~XCoolSub2Menu(void)
{
	TerminateLog();
	delete subact1;
	delete subact2;
	delete subact3;
	delete subsel1;
	delete subsel2;
	delete subsel3;
}


void z2_1()
{
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z2_1()!", "Menu action!", MB_OK);
	fOut2 << "action in z2_1" << endl;
}

void z2_2()
{
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z2_2()!", "Menu action!", MB_OK);
	fOut2 << "action in z2_2" << endl;
}
 
void z2_3()
{
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z2_3()!", "Menu action!", MB_OK);
	fOut2 << "action in z2_3" << endl;
}


int XCoolSubActive1::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z2_1();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}

int XCoolSubActive2::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z2_2();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}

int XCoolSubActive3::ChangeState(const XEvent &e)
{
	return XMenuActive::ChangeState(e);
}

int XCoolSubSelected3::ChangeState(const XEvent &e)
{
	// Nested automat call here
	((CMainFrame*)(theApp.m_pMainWnd))->m_tmpSub2.ReceiveEvent(e);

	return XMenuSelected::ChangeState(e);
}

void XCoolSubSelected3::EnterInfluence()
{
	XEvent e;
	e.m_Number = 0;
	// Nested automat initialization
	((CMainFrame*)(theApp.m_pMainWnd))->m_tmpSub2.ReceiveEvent(e);

	XMenuSelected::EnterInfluence();
}

/*****************************************************************************************
** Sub2 Menu ******************************************************************************
*****************************************************************************************/
XCoolSub2Active1* sub2act1;
XCoolSub2Active2* sub2act2;
XCoolSub2Active3* sub2act3;

XMenuSelected* sub2sel1;
XMenuSelected* sub2sel2;
XMenuSelected* sub2sel3;


XCoolSub3Menu::XCoolSub3Menu(void)
{

	sub2act1 = new XCoolSub2Active1("Active 1");
	sub2act2 = new XCoolSub2Active2("Active 2");
	sub2act3 = new XCoolSub2Active3("Active 3");

	sub2sel1 = new XMenuSelected("Selected 1");
	sub2sel2 = new XMenuSelected("Selected 2");
	sub2sel3 = new XMenuSelected("Selected 3");

	SetTitle("A2");
	XCoolClosed* cls = new XCoolClosed("Closed");
	InsertState(cls, 0);
	((XStateEx*)(GetState(0)))->SetParent(this);
	((XStateEx*)(GetState(1)))->SetParent(this);
	((XStateEx*)(GetState(1)))->SetTitle("Waiting");
	sub2act1->SetParent(this);
	sub2act2->SetParent(this);
	sub2act3->SetParent(this);
	sub2sel1->SetParent(this);
	sub2sel2->SetParent(this);
	sub2sel3->SetParent(this);
	AddState(sub2act1);
	AddState(sub2sel1);
	AddState(sub2act2);
	AddState(sub2sel2);
	AddState(sub2act3);
	AddState(sub2sel3);
}

XCoolSub3Menu::~XCoolSub3Menu(void)
{
	TerminateLog();
	delete sub2act1;
	delete sub2act2;
	delete sub2act3;
	delete sub2sel1;
	delete sub2sel2;
	delete sub2sel3;
}


void z3_1()
{
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z3_1()!", "Menu action!", MB_OK);
	fOut2 << "action in z3_1" << endl;
}

void z3_2()
{
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z3_2()!", "Menu action!", MB_OK);
	fOut2 << "action in z3_2" << endl;
}
 
void z3_3()
{
	MessageBox(*((CMainFrame*)(theApp.m_pMainWnd)), "Action in z3_3()!", "Menu action!", MB_OK);
	fOut2 << "action in z3_3" << endl;
}


int XCoolSub2Active1::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z3_1();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}

int XCoolSub2Active2::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z3_2();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}

int XCoolSub2Active3::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1008) 
	{
		z3_3();
		return 0;
	}
	return XMenuActive::ChangeState(e);
}
