#include "xmenub.h"

XMenuB::XMenuB(void) :  XAutomat("Untitled Menu", 2)
{	
	XMenuClosed* closed = new XMenuClosed[1];
	XMenuWaiting* waiting = new XMenuWaiting[1];
	AddState(closed);
	AddState(waiting);

	m_counter = 0;
}

XMenuB::XMenuB(const char* clTitle, const char* wtTitle, int num) : XAutomat("Untitled Menu", num)
{	
	XMenuClosed* closed = new XMenuClosed[1];
	closed->SetTitle(clTitle);
	XMenuWaiting* waiting = new XMenuWaiting[1];
	waiting->SetTitle(wtTitle);
	AddState(closed);
	AddState(waiting);
}

XMenuB::~XMenuB(void)
{
}


XMenuClosed::XMenuClosed(void) : XStateEx("Untitled MenuClosed")
{
}

XMenuClosed::XMenuClosed(const char* title) : XStateEx(title)
{
}


XMenuClosed::~XMenuClosed(void)
{
}

int XMenuClosed::ChangeState(const XEvent &e)
{
	if (e.m_Number == 1001) return 1;
	return 0;
}

void XMenuClosed::EnterInfluence()
{
((XMenuB*)GetParent())->z3();
}


XMenuWaiting::XMenuWaiting(void) : XStateEx("Untitled MenuWaiting")
{
}

XMenuWaiting::XMenuWaiting(const char* title) : XStateEx(title)
{
}


XMenuWaiting::~XMenuWaiting(void)
{
}

int XMenuWaiting::ChangeState(const XEvent &e)
{
	switch (e.m_Number)
	{
	case 1004:
		return 0;
	case 1008:
		return 0;
	case 1007:
		return 0;
	case 1002:
		return (*((int*)(e.m_Info))) * 2;
	default:
		return 1;	
	}
}

void XMenuWaiting::EnterInfluence()
{
}


XMenuSelected::XMenuSelected(void) : XStateEx("Untitled MenuSelected")
{
}

XMenuSelected::XMenuSelected(const char* title) : XStateEx(title)
{
}

XMenuSelected::~XMenuSelected(void)
{
}

int XMenuSelected::ChangeState(const XEvent &e)
{
	XMenuB* parent = (XMenuB*)GetParent();
	switch (e.m_Number)
	{
	case 1007:
 		if (!parent->x1())
		{
			parent->z1();
			return parent->GetCurrentState() - 1;
		}
		if (parent->x1()){
			parent->z1();
			return GetParent()->GetCurrentState();
		}
	
	case 1003:
		parent->z2();
		return GetParent()->GetCurrentState();

	case 1008:
		return 0;

	default:
		return GetParent()->GetCurrentState(); 
		break;
	}
}

void XMenuSelected::EnterInfluence()
{
((XMenuB*)GetParent())->z2();
}


XMenuActive::XMenuActive(void) : XStateEx("Untitled MenuActive")
{
}

XMenuActive::XMenuActive(const char* title) : XStateEx(title)
{
}


XMenuActive::~XMenuActive(void)
{
}

int XMenuActive::ChangeState(const XEvent &e)
{
	XMenuB* tmp = (XMenuB*)GetParent();
	int curr = tmp->GetCurrentState();

	switch (e.m_Number)
	{
	case 1001:
		return 1;
	case 1002:
		return (*((int*)(e.m_Info))) * 2;		
	case 1005:
		if (GetParent()->GetState(curr + 2) != 0)
		{
			return curr + 2;
		}
		else 
		{
			return 2;
		}
		break;
	case 1006:
		if (curr > 2)
		{
			return curr - 2;
		}
		else 
		{
			return GetParent()->GetStatesNumber() - 2;
		}
		
	case 1003:
		return GetParent()->GetCurrentState() + 1;
		break;
	case 1007:
		return 0;
		break;
	case 1008:		
		// Action here (useful menu item action) depends on 
		// implementation and might be redefined in a child classes.
		return 0;
	default:
		return GetParent()->GetCurrentState(); 
		break;
	
	}

}

void XMenuActive::EnterInfluence()
{
}

void XMenuB::z1()
{
	m_counter--;
}

void XMenuB::z2()
{
	m_counter++;
}

void XMenuB::z3()
{
	m_counter = 0;
}

bool XMenuB::x1()
{
	return m_counter > 1;
}
