#pragma once
#include "afxwin.h"

enum MENU_DIRECTION 
{
	MD_VERTICAL  = false,
	MD_HORIZONTAL = true
};

class XTmpWnd :
	public CWnd
{
	DECLARE_DYNAMIC(XTmpWnd)

private:
	MENU_DIRECTION	m_Direction;

	int			m_ItemsNumber;
	int			m_ItemWidth;
	int			m_ItemHeight;

	char**		m_ItemTitles;

	int			m_X0;
	int			m_Y0;

	COLORREF	m_DefaultColor;
	COLORREF	m_ActiveColor;
	COLORREF	m_SelectedColor;
	COLORREF	m_TextColor;

	CFont		m_Font;

	int			m_CurrentTitle;

public:
	XTmpWnd(void);
	~XTmpWnd(void);

	void SetCoordinates(int x, int y);
	inline void SetDirection(MENU_DIRECTION dir) {m_Direction = dir;}

	inline int GetItemWidth(void) {return m_ItemWidth;}
	inline int GetItemHeight(void) {return m_ItemHeight;}
	inline CFont* GetFont(void) {return &m_Font;}
	void GetSubMenuCoordinates(int &x, int &y, int num);

	RECT GetMenuRect(void);

	virtual void DrawDefaultItem(CPaintDC* dc, int num);
	virtual void DrawActiveItem(CPaintDC* dc, int num);
	virtual void DrawSelectedItem(CPaintDC* dc, int num);

	bool AddItemTitle(char* title);
	bool InsertItemTitle(char* title, int num);
	void InitItemTitles(int num);
	void ClearItemTitles();

	inline int GetItemsNumber(void){return m_ItemsNumber;}
	inline MENU_DIRECTION GetDirection(void) {return m_Direction;}
	
	void Show();
	void Hide();

private:
	void DrawItem(CPaintDC* dc, COLORREF c, int num);

protected:
	DECLARE_MESSAGE_MAP()
};
